
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class QuotesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quotes = await db.quotes.create(
            {
                id: data.id || undefined,
        
        quote_number: data.quote_number
        ||
        null
            ,
            
        requested_at: data.requested_at
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
        quote_status: data.quote_status
        ||
        null
            ,
            
        quote_total: data.quote_total
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await quotes.setAccount( data.account || null, {
            transaction,
        });
        
        await quotes.setLocation( data.location || null, {
            transaction,
        });
        
        await quotes.setRequested_by( data.requested_by || null, {
            transaction,
        });
        
        await quotes.setOwner( data.owner || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.quotes.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: quotes.id,
            },
            data.attachments,
            options,
        );
        

        return quotes;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const quotesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quote_number: item.quote_number
            ||
            null
            ,
            
                requested_at: item.requested_at
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
                quote_status: item.quote_status
            ||
            null
            ,
            
                quote_total: item.quote_total
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const quotes = await db.quotes.bulkCreate(quotesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < quotes.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.quotes.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: quotes[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return quotes;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const quotes = await db.quotes.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quote_number !== undefined) updatePayload.quote_number = data.quote_number;
        
        
        if (data.requested_at !== undefined) updatePayload.requested_at = data.requested_at;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        if (data.quote_status !== undefined) updatePayload.quote_status = data.quote_status;
        
        
        if (data.quote_total !== undefined) updatePayload.quote_total = data.quote_total;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await quotes.update(updatePayload, {transaction});

        
        
        if (data.account !== undefined) {
            await quotes.setAccount(
              
              data.account,
              
              { transaction }
            );
        }
        
        if (data.location !== undefined) {
            await quotes.setLocation(
              
              data.location,
              
              { transaction }
            );
        }
        
        if (data.requested_by !== undefined) {
            await quotes.setRequested_by(
              
              data.requested_by,
              
              { transaction }
            );
        }
        
        if (data.owner !== undefined) {
            await quotes.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.quotes.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: quotes.id,
            },
            data.attachments,
            options,
        );
        

        return quotes;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const quotes = await db.quotes.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of quotes) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of quotes) {
                await record.destroy({transaction});
            }
        });


        return quotes;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const quotes = await db.quotes.findByPk(id, options);

        await quotes.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await quotes.destroy({
            transaction
        });

        return quotes;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const quotes = await db.quotes.findOne(
            { where },
            { transaction },
        );

        if (!quotes) {
            return quotes;
        }

        const output = quotes.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.quote_items_quote = await quotes.getQuote_items_quote({
            transaction
        });
        
        
        
        
        
        
        output.account = await quotes.getAccount({
            transaction
        });
        
        
        output.location = await quotes.getLocation({
            transaction
        });
        
        
        output.requested_by = await quotes.getRequested_by({
            transaction
        });
        
        
        output.owner = await quotes.getOwner({
            transaction
        });
        
        
        output.attachments = await quotes.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.accounts,
        as: 'account',
        
        where: filter.account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_name: {
                [Op.or]: filter.account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.locations,
        as: 'location',
        
        where: filter.location ? {
          [Op.or]: [
            { id: { [Op.in]: filter.location.split('|').map(term => Utils.uuid(term)) } },
            {
              location_name: {
                [Op.or]: filter.location.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'requested_by',
        
        where: filter.requested_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requested_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.requested_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.quote_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quotes',
                        'quote_number',
                        filter.quote_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'quotes',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.requested_atRange) {
                const [start, end] = filter.requested_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.quote_totalRange) {
                const [start, end] = filter.quote_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quote_total: {
                    ...where.quote_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quote_total: {
                    ...where.quote_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.quote_status) {
                where = {
                    ...where,
                quote_status: filter.quote_status,
            };
            }
            


      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.quotes.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'quotes',
                        'quote_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.quotes.findAll({
            attributes: [ 'id', 'quote_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['quote_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.quote_number,
        }));
    }

    
};

